<?php
require "./global.php";

checkadminpermissions("caneditdownloads");
logadmin();

switch($action)
{
	case "add":
		addacpnav("Add Download or Category");
		break;
	case "delete":
		addacpnav("Delete Download or Category");
		break;
	case "edit":
		if($did)
		{
			addacpnav("Edit Download");
		}
		if($cid)
		{
			addacpnav("Edit Category");
		}
		break;
	case "validate":
		addacpnav("Validate Download Submissions");
		break;
	case "modify":
	default:
		addacpnav("Download Management");
		break;
}

if($action == "do_add")
{
	if($type == "category")
	{
		$name = addslashes($name);
		$description = addslashes($description);
		$query = $db->query("INSERT INTO ".TABLE_PREFIX."downloadcategories VALUES ('','$name','$description','$allowsubmissions','$visible','$disporder')");
		cpredirect("downloads.php", "Download Category Added");
	}
	elseif($type == "download")
	{
		$name = addslashes($name);
		$description = addslashes($description);
		$url = addslashes($url);
		$query = $db->query("INSERT INTO ".TABLE_PREFIX."forumdownloads VALUES ('','$cid','$mybbadmin[uid]','$name','$description','$url','$visible','$sticky','yes')");
		cpredirect("downloads.php", "Download Added");
	}
}

if($action == "do_delete")
{
	if($deletesubmit)
	{
		if($did)
		{
			$query = $db->query("DELETE FROM ".TABLE_PREFIX."forumdownloads WHERE did='$did'");
			cpredirect("downloads.php", "Download Deleted");
		}
		elseif($cid)
		{
			$query = $db->query("DELETE FROM ".TABLE_PREFIX."downloadcategories WHERE cid='$cid'");
			cpredirect("downloads.php", "Download Category Deleted");
		}
		else
		{
			$action = "modify";
		}
	}
}

if($action == "do_edit")
{
	if($did)
	{
		$name = addslashes($name);
		$description = addslashes($description);
		$url = addslashes($url);
		$query = $db->query("UPDATE ".TABLE_PREFIX."forumdownloads SET cid='$cid', uid='$uid', name='$name', description='$description', url='$url', sticky='$sticky', visible='$visible' WHERE did='$did'");
		cpredirect("downloads.php", "Download Modified");
	}
	elseif($cid)
	{
		$name = addslashes($name);
		$description = addslashes($description);
		$query = $db->query("UPDATE ".TABLE_PREFIX."downloadcategories SET name='$name', description='$description', visible='$visible', allowsubmissions='$allowsubmissions', disporder='$disporder' WHERE cid='$cid'");
		cpredirect("downloads.php", "Download Category Modified");
	}
	else
	{
		$action = "modify";
	}
}

if($action == "do_validate")
{
	if(is_array($validated))
	{
		while(list($did, $val) = each($validated))
		{
			$query = $db->query("SELECT * FROM ".TABLE_PREFIX."forumdownloads WHERE did='$did'");
			$download = $db->fetch_array($query);
			if($delete[$did] == "yes")
			{
				$db->query("DELETE FROM ".TABLE_PREFIX."forumdownloads WHERE did='$did'");
			}
			else
			{
				if($val != "no")
				{
					$name[$did] = addslashes($name[$did]);
					$description[$did] = addslashes($description[$did]);
					$url[$did] = addslashes($url[$did]);
					$db->query("UPDATE ".TABLE_PREFIX."forumdownloads SET cid='$cid[$did]', name='$name[$did]', url='$url[$did]', description='$description[$did]', visible='$visible[$did]', sticky='$sticky[$did]', validated='$validated[$did]' WHERE did='$did'");
				}
			}
		}
	}
	cpredirect("downloads.php", "The selected links have been successfully validated or deleted.");
}

if($action == "add")
{
	cpheader();
	startform("downloads.php", "", "do_add");
	makehiddencode("type", "category");
	starttable();
	tableheader("Add Download Category");
	makeinputcode("Category Name", "name");
	maketextareacode("Category Description", "description");
	makeyesnocode("Category Is Visible?", "visible", "yes");
	makeyesnocode("Allow User Submissions?", "allowsubmissions", "no");
	makeinputcode("Display Order", "disporder", "1", "4");
	endtable();
	endform("Add Download Category", "Reset");
	
	$query = $db->query("SELECT COUNT(*) AS numcats FROM ".TABLE_PREFIX."downloadcategories");
	$count = $db->fetch_array($query);
	if($count['numcats'] > 0)
	{
		echo "<br />\n";
		startform("downloads.php", "", "do_add");
		makehiddencode("type", "download");
		starttable();
		tableheader("Add Download");
		makeinputcode("Download Name", "name");
		maketextareacode("Download Description", "description");
		makeinputcode("Download URL", "url");
		makeselectcode("Category", "cid", "downloadcategories", "cid", "name");
		makeyesnocode("Download Is Visible?", "visible");
		makeyesnocode("Download Is Sticky?", "sticky", "no");
		endtable();
		endform("Add Download", "Reset");
	}
	
	cpfooter();
}

if($action == "delete")
{
	cpheader();
	if($did)
	{
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."forumdownloads WHERE did='$did'");
		$download = $db->fetch_array($query);
		startform("downloads.php", "", "do_delete");
		makehiddencode("did", $did);
		starttable();
		tableheader("Delete Download");
		$yes = makebuttoncode("deletesubmit", $lang->yes);
		$no = makebuttoncode("no", $lang->no);
		makelabelcode("<center>Are you sure you would like to delete the download named $download[name]?<br><br>$yes$no</center>", "");
		endtable();
		endform();
	}
	elseif($cid)
	{
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."downloadcategories WHERE cid='$cid'");
		$category = $db->fetch_array($query);
		startform("downloads.php", "", "do_delete");
		makehiddencode("cid", $cid);
		starttable();
		tableheader("Delete Download Category");
		$yes = makebuttoncode("deletesubmit", $lang->yes);
		$no = makebuttoncode("no", $lang->no);
		makelabelcode("<center>Are you sure you would like to delete the download category named $category[name]?<br><br>$yes$no</center>", "");
		endtable();
		endform();
	}
	cpfooter();
}

if($action == "edit")
{
	cpheader();
	if($cid)
	{
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."downloadcategories WHERE cid='$cid'");
		$category = $db->fetch_array($query);
		$category['description'] = stripslashes($category['description']);
		startform("downloads.php", "", "do_edit");
		starttable();
		tableheader("Modify Download Category");
		makeinputcode("Category Name", "name", $category['name']);
		maketextareacode("Category Description", "description", $category['description']);
		makeyesnocode("Category Is Visible?", "visible", $category['visible']);
		makeyesnocode("Allow User Submissions?", "allowsubmissions", $category['allowsubmissions']);
		makeinputcode("Display Order", "disporder", $category['disporder'], "4");
		endtable();
		makehiddencode("cid", $cid);
		endform("Modify Category", $lang->reset_button);
	}
	elseif($did)
	{
		$query = $db->query("SELECT * FROM ".TABLE_PREFIX."forumdownloads WHERE did='$did'");
		$download = $db->fetch_array($query);
		$download['description'] = stripslashes($download['description']);
		startform("downloads.php", "", "do_edit");
		starttable();
		tableheader("Modify Download");
		makeinputcode("Download Name", "name", $download['name']);
		maketextareacode("Download Description", "description", $download['description']);
		makeselectcode("Category", "cid", "downloadcategories", "cid", "name", $download['cid']);
		makeinputcode("File URL", "url", $download['url']);
		makeyesnocode("Download Is Visible?", "visible", $download['visible']);
		makeyesnocode("Download Is Sticky?", "sticky", $download['sticky']);
		endtable();
		makehiddencode("did", $did);
		endform("Modify Download", "Reset");
	}
	cpfooter();
}

if($action == "validate")
{
	if(!$noheader)
	{
		cpheader();
	}
	
	startform("downloads.php", "", "do_validate");
	starttable();
	tableheader("Download Submissions");
	$query = $db->query("SELECT d.*, u.uid, u.username FROM ".TABLE_PREFIX."forumdownloads d LEFT JOIN ".TABLE_PREFIX."users u ON (u.uid=d.uid) WHERE validated!='yes'");
	while($download = $db->fetch_array($query))
	{
		makeinputcode("Download Name", "name[$download[did]]", $download['name']);
		makelabelcode("Submitted By", "<a href=\"users.php?action=edit&uid=$download[uid]\">$download[username]</a>");
		maketextareacode("Description", "description[$download[did]]", $download['description']);
		makeselectcode("Category", "cid[$download[did]]", "downloadcategories", "cid", "name", $download['cid']);
		makeinputcode("File URL", "url[$download[did]]", $download['url']);
		makeyesnocode("Download Is Visible?", "visible[$download[did]]", "yes");
		makeyesnocode("Download Is Sticky?", "sticky[$download[did]]", "no");
		makeyesnocode("Submission Is Validated?", "validated[$download[did]]", "yes");
		makeyesnocode("Delete Submission?", "delete[$download[did]]", "no");
		echo "<tr>\n<td class=\"subheader\" align=\"center\" colspan=\"2\" height=\"2\"><img src=\"pixel.gif\" width=\"1\" height=\"1\"></td>\n</tr>\n";
	}
	endtable();
	endform("Validate / Delete Submissions");
}

if($action == "modify" || $action == "")
{
	if(!$noheader)
	{
		cpheader();
	}
	$query = $db->query("SELECT * FROM ".TABLE_PREFIX."downloadcategories ORDER BY disporder");
	while($category = $db->fetch_array($query))
	{
		$categories .= "<li><b>$category[name]</b>".
			makelinkcode("edit", "downloads.php?action=edit&cid=$category[cid]").
			makelinkcode("delete", "downloads.php?action=delete&cid=$category[cid]").
			"<ul>\n";
		$query2 = $db->query("SELECT * FROM ".TABLE_PREFIX."forumdownloads WHERE cid='$category[cid]' AND validated='yes' ORDER BY sticky DESC");
		while($download = $db->fetch_array($query2))
		{
			$categories .= "<li>$download[name]".
				makelinkcode("edit", "downloads.php?action=edit&did=$download[did]").
				makelinkcode("delete", "downloads.php?action=delete&did=$download[did]").
				"</li>\n";
		}
		$categories .= "</ul>\n</li>\n";
	}
	starttable();
	tableheader("Downloads");
	tablesubheader("Select a download or download category from below to edit or delete.");
	makelabelcode("<ul>\n$categories</ul>");
	endtable();
	cpfooter();
}
?>